"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SideBar = SideBar;
function _react() {
  const data = _interopRequireWildcard(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _lodash() {
  const data = require("lodash");
  _lodash = function () {
    return data;
  };
  return data;
}
function _classnames() {
  const data = _interopRequireDefault(require("classnames"));
  _classnames = function () {
    return data;
  };
  return data;
}
function _designUiSurfacesMenu() {
  const data = require("@teambit/design.ui.surfaces.menu.section");
  _designUiSurfacesMenu = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiTree() {
  const data = require("@teambit/ui-foundation.ui.tree.drawer");
  _uiFoundationUiTree = function () {
    return data;
  };
  return data;
}
function _sideBarModule() {
  const data = _interopRequireDefault(require("./side-bar.module.scss"));
  _sideBarModule = function () {
    return data;
  };
  return data;
}
const _excluded = ["drawerSlot", "items", "overrideDrawerSlot"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
/**
 * side bar component.
 */
function SideBar(_ref) {
  let {
      drawerSlot,
      items = [],
      overrideDrawerSlot
    } = _ref,
    rest = _objectWithoutProperties(_ref, _excluded);
  const drawers = (overrideDrawerSlot || (0, _lodash().flatten)(drawerSlot.values())).filter(drawer => {
    var _drawer$isHidden;
    return !(drawer !== null && drawer !== void 0 && (_drawer$isHidden = drawer.isHidden) !== null && _drawer$isHidden !== void 0 && _drawer$isHidden.call(drawer));
  }).sort(sortFn);
  const [openDrawerList, onToggleDrawer] = (0, _react().useState)(drawers.map(drawer => drawer.id));
  const handleDrawerToggle = id => {
    const isDrawerOpen = openDrawerList.includes(id);
    if (isDrawerOpen) {
      onToggleDrawer(list => list.filter(drawer => drawer !== id));
      return;
    }
    onToggleDrawer(list => list.concat(id));
  };
  return /*#__PURE__*/_react().default.createElement("div", _extends({}, rest, {
    className: _sideBarModule().default.sidebar
  }), /*#__PURE__*/_react().default.createElement(_designUiSurfacesMenu().MenuSection, {
    items: items
  }), drawers.map(drawer => {
    if (!drawer || !drawer.name) return null;
    // consider passing collapse all as a prop so each drawer collapses itself
    const isOpen = openDrawerList.includes(drawer.id);
    return /*#__PURE__*/_react().default.createElement(_uiFoundationUiTree().DrawerUI, {
      className: (0, _classnames().default)(_sideBarModule().default.sidebarDrawer, isOpen && _sideBarModule().default.open),
      isOpen: isOpen,
      onToggle: () => handleDrawerToggle(drawer.id),
      key: drawer.id,
      name: drawer.name,
      Widgets: drawer.widgets,
      Context: drawer.Context
    }, /*#__PURE__*/_react().default.createElement(drawer.render, null));
  }));
}
function sortFn(first, second) {
  // 0  - equal
  // <0 - first < second
  // >0 - first > second

  return (first.order ?? 0) - (second.order ?? 0);
}

//# sourceMappingURL=side-bar.js.map